// *********************************************************************************
// Scheme for the variables list
// *********************************************************************************

import {variables} from "./variables";

export const variableScheme = {
    hash: 'UUID for the variable',
    name: 'Variable name',
    type: 'Varaible type',
    value: 'Variable value'
};

// *********************************************************************************
// Variable types
// *********************************************************************************

export const variableTypes = [
    {
        name: 'inteiro',
        value: 'INTEGER',
        defaultValue: 0,
        htmlType: 'number',
        barrier: ''
    },
    {
        name: 'real',
        value: 'DOUBLE',
        defaultValue: 0.0,
        htmlType: 'number',
        barrier: ''
    },
    {
        name: 'cadeia',
        value: 'STRING',
        defaultValue: '',
        htmlType: 'text',
        barrier: '"'
    },
    {
        name: 'lógico',
        value: 'BOOLEAN',
        vales: [
            {
                name: 'verdadeiro',
                value: true
            },
            {
                name: 'falso',
                value: false
            }
        ],
        defaultValue: true,
        htmlType: 'select',
        barrier: ''
    }
];

export function getVariableTypeByValue (value) {
    for (let i = 0; i < variableTypes.length; i++) {
        if (variableTypes[i].value === value)
            return variableTypes[i];
    }

    return null;
}

// *********************************************************************************
// Html Schemes
// *********************************************************************************

let htmlVariableSchemeBuilt = '';

export function htmlVariableScheme () {

    if (htmlVariableSchemeBuilt !== '')
        return htmlVariableSchemeBuilt;

    let variableTypesHtml = '';

    for (let i = 0; i < variableTypes.length; i++) {
        variableTypesHtml += `<option value="${variableTypes[i].value}">${variableTypes[i].name}</option>\n`;
    }

    return `<li id="variable<variableId>Li">
                <form id="variable<variableId>Form">
                    <div class="row p-2 w-100 variable-item" style="background-color: antiquewhite;">
                        <!-- <div class="col-1 text-center my-auto">
                           <h5>${variables.length}</h5>
                        </div> -->
                        <div class="col-2">
                            <select name="tipo" class="form-control" title="Tipo da variável" id="variable<variableId>Type" variable-id="<variableId>">
                                ${variableTypesHtml}
                            </select>
                        </div>
                        <div class="col-2">
                            <input type="text" class="form-control" title="nome da variável" id="variable<variableId>Name" value="<variableName>" variable-id="<variableId>">
                        </div>
                        <div class="col-1 text-center my-auto" style="margin-bottom: 0px !important">
                            <label for="variable<variableId>Value" tabindex="0" title="Recebe">recebe</label>
                        </div>
                        <div class="col-2">
                            <input type="${variableTypes[0].htmlType}" class="form-control" id ="variable<variableId>Value" title="Valor da variável" value="0" variable-id="<variableId>">
                        </div>
                        <div class="col my-auto" style="text-align: end;">
                            <div class="row justify-content-end">
                                <div class="col-1">
                                    <a id="variable<variableId>Resume" href="javascript:void(0)" class="text-info" variable-id="<variableId>">
                                        <i class="fas fa-eye"></i>
                                    </a>
                                </div>
                                <div class="col-1">
                                    <a id="variable<variableId>Delete" href="javascript:void(0)" class="text-danger" variable-id="<variableId>" title="Excluir">X</a>
                                </div>
                            </div>
                        </div>
                    </div>
                </form> 
          </li>`;
}

// *********************************************************************************